import processing.data.StringList;
import org.apache.tools.ant.types.resources.comparators.Date;

/*
class demo on Jan 15, 2015
 By Mohit Hingorani
 please email me at mohit@mat.ucsb.edu
 */


int [][] dataMatrix = null;
String [][] dataMatrix1 = null;
int maxCount ;
int numRows, numColumns;

PFont font = createFont( "Helvetica", 16, true);
PFont font_1;
Table myTable;

void setup()
{
  size( 1000, 780);      
  background(0);      
  smooth();     
  frameRate(10);     
 
  myTable = loadTable( "data2013.csv", "header");           
  numRows = myTable.getRowCount();
  numColumns = myTable.getColumnCount();
  
  dataMatrix = new int[numRows][numColumns];
 
  for ( int i = 0; i< numRows; i++)
  {
    for ( int j = 0; j< numColumns; j++)
    {
      dataMatrix[i][j] = myTable.getInt(i, j);                
      print( dataMatrix[i][j] + " ");
    }
  }

  maxCount = dataMatrix[0][0];

  for ( int i = 0; i< numRows; i++)
  {
    for ( int j = 0; j< 2; j++)
    {
      if ( dataMatrix[i][j] > maxCount) maxCount = dataMatrix[i][j];
    }
  }
  
  println( numRows +"  "+ numColumns + " " + maxCount );
  println(maxCount);

}


void draw() {
  background(164,198,184);
  fill(222,237,226);
  noStroke();  
  rect(760,0,280,1800);
  
     fill(234,142,71);
     noStroke();  
     rect(760,342,15,363);//comicbooks
   
     fill(160,128,77);
     noStroke();  
     rect(775,471,15,234);//us
   
     fill(80,63,35);
     noStroke();  
     rect(790,631,15,74);//japan
   
     fill(4,5,6);
     noStroke();  
     rect(805,685,15,20);//harry
  
   translate( 70, 50);  
   noStroke();
  

      font_1 = createFont("Calibri-Bold",26);
      textFont(font_1,26);
      textSize(26);
      fill(0,102,153,204);
      textAlign(LEFT);
      text("Comic books\nCheckout\nBy countries\n2013", 705,20);
      
      textFont(font_1,20);
      textSize(20);
      fill(0,102,153,204);
      textAlign(LEFT);
      text("Sakura-Con\nMarch 29-31", 705,220);
       
      textFont(font_1,20);
      textSize(20);
      fill(234,142,71);
      textAlign(LEFT);
      text("Comic books\n 741.5", 710,310);
          
      textFont(font_1,26);
      textSize(16);
      fill(160,128,77);
      textAlign(LEFT);
      text("Comic books-US\n 741.5973", 725,433);
            
      textFont(font_1,26);
      textSize(16);
      fill(80,63,35);
      textAlign(LEFT);
      text("Comic books-Japan\n 741.5952", 740,593);
     
      textFont(font_1,26);
      textSize(16);
      fill(5,4,2);
      textAlign(LEFT);
      text("Harry Potter books", 755,650);

      /*
      for(TableRow row : myTable.rows()){      
      String checkoutdate = row.getString("Year 2013");     
      String[] list = split(checkoutdate, "  ");  
         for (int k = 0; k < list.length; k++){
              textAlign(CENTER);
              textSize(22);
              text(list[k],k*100+500,k*100);            
             println(checkoutdate); 
             println(list.length);  
             println(list.getRowCount());
       }
     }
     
     */
         
  for ( int  i = 1; i< numRows  ; i++) 
  {
    for ( int  j = 1; j < numColumns  ; j++) 
    {    
      fill( 349* dataMatrix[i][j] / maxCount 
      , 249* dataMatrix[i][j] / maxCount
      , 149* dataMatrix[i][j] / maxCount);   
      
      rect( i * 60 - 65,  j +650 , 43,  -dataMatrix[i][j]/30  ); 
       
      font_1 = loadFont("Helvetica-48.vlw");    
      textSize(14);
      fill(0,102,153,204);
      textAlign(RIGHT);
      text(dataMatrix[i][j]+5,i*60-23,-dataMatrix[i][j]/29.8 + 653);
       
    }
  if ( frameCount % 20 ==0) println( "draw called " + frameCount );
  }
  
  for(int q = 1; q < numRows; q++){
     String s = myTable.getString(q,0);
     //println(s);
    
     textFont(font_1,15);
     textSize(15);
     fill(160,128,77);
     textAlign(LEFT);
    
     //pushMatrix();
     rotate(-PI/3.2);
     //translate(0,20*q);
     translate(0,51); 
     text(s, q*34-100,0);
     rotate(PI/3.2);
     //translate(0,-20*q);
     //popMatrix();
         
     }
    
  //save("datahw_intae.jpg");
}
